
#include <stdio.h>
#include <stdlib.h>
#include "rcm.h"

static void	Error(path,msg)
char		*path,*msg;
{
	fprintf(stderr,"%s : %s\n",path,msg); exit(1);
}

int		ReadCM(path,R,G,B)
char		*path;
unsigned short	**R,**G,**B;
{
	FILE	*file;
	int	cms,idx;

	if (path[0]=='-')
	    file=stdin;
	else
	    if ((file=fopen(path,"r"))==NULL)
		Error(path,"colormap file not found.");

	if (fscanf(file,"%d",&cms)!=1 || cms<=0)
	    Error(path,"bad colormap number.");

	if ((*R=(unsigned short *)malloc(cms*sizeof(**R)))==NULL ||
	    (*G=(unsigned short *)malloc(cms*sizeof(**G)))==NULL ||
	    (*B=(unsigned short *)malloc(cms*sizeof(**B)))==NULL)
	    Error(path,"colormap memory allocation error.");

	for (idx=0; idx<cms; idx++)
	    if (fscanf(file,"%hu %hu %hu",*R+idx,*G+idx,*B+idx)!=3)
		Error(path,"colormap data read error.");

	if (file!=stdin) fclose(file);

	return cms;
}
